.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include masm32.inc
   include comdlg32.inc
   include shell32.inc
   include Test_ShineInHex.inc
   include tabs.asm
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib
   includelib masm32.lib
   includelib comdlg32.lib
   includelib shell32.lib

OpenFileDlg   proto :DWORD,:DWORD,:DWORD,:DWORD
GetFileName   proto :DWORD
find_themes   proto :DWORD
WinMain       proto :DWORD,:DWORD,:DWORD,:DWORD
DoOpenProfile proto
DoSaveProfile proto
ChooseProc    proto :DWORD,:DWORD,:DWORD,:DWORD

.data
	ini_file db "sih.ini",0
			 db 64 dup (0)
	sih_ini  db "sih.ini",0
	ini_hex  db "%#08x",0
	ini_sec1 db "HEXEDITOR",0
	sih      db "ShineInHex.dll",0
	sihc     db "SHINEINHEX",0
	sihe     db "{cannot open file}",0
	sihh     dd 0
	fname    dd 0
	file     dd 0
	pointer  dd 0
	fsize    dd 0
	hmap     dd 0
	col_st   dd 2 dup (0)
	col_br   dd 2 dup (0)
	hex_offset dd 0
	font_num   dd 0
	colors   dd 0FF8080h,0FFFFFFH,0808080H,0FFFFFFH,0000000H,0FF8080H,0000000H,0000000H
		     dd 0FFFFFFH,0800000H,0FFFFFFH,0008000H,0FF8080H,0C0FFC0H,0808000H,0FFFFFFH
		     dd 00000FFH,0FFFFFFH,0FFFFFFH,00000F0H,0FFFFFFH,00000B0H,0FFFFFFH,0000070H
    tbt TBBUTTON { 0, 900, TBSTATE_ENABLED, BTNS_BUTTON, 0, 0},
        	     { 1, 901, TBSTATE_ENABLED, BTNS_BUTTON, 0, 0},
        	     { 2, 902, TBSTATE_ENABLED, BTNS_BUTTON, 0, 0}

;--------------
	sih_rc_cx  dd 0
	sih_rc_cy  dd 0
	tab_cy     dd 31

.const
	HEXM_SETFONT          equ WM_USER+100 ;{wParam-font_number: 0 - Fixedsys, 1 - Courier, 2 - Terminal, 3 - Courier New, 4 - Lucida Console} {lParam-0}
	HEXM_SETOFFSETGRADCOL equ WM_USER+101 ;{wParam-grad_start_color}{lParam-grad_end_color	 }
	HEXM_SETHEADERGRADCOL equ WM_USER+102 ;{wParam-grad_start_color}{lParam-grad_end_color	 }
	HEXM_SETVIEW1TEXTCOL  equ WM_USER+103 ;{wParam-info_text_color }{lParam-view1_text_color }
	HEXM_SETHEADERTEXTCOL equ WM_USER+104 ;{wParam-addr_text_color }{lParam-switch_text_color}
	HEXM_SETVIEW2COL      equ WM_USER+105 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETVIEW3COL      equ WM_USER+106 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETVIEW2SELCOL   equ WM_USER+107 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETVIEW3SELCOL   equ WM_USER+108 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETACTIVECHARCOL equ WM_USER+109 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETMODBYTES1COL  equ WM_USER+110 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETMODBYTES2COL  equ WM_USER+111 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETMODBYTES3COL  equ WM_USER+112 ;{wParam-bk_color}     	{lParam-text_color}
	HEXM_SETPOINTER       equ WM_USER+113 ;{wParam-data pointer} 	{lParam-data size }
	HEXM_UNSETPOINTER     equ WM_USER+114 ;{wParam-0}            	{lParam-0         }
	HEXM_SETOFFSET        equ WM_USER+115 ;{wParam-offset}       	{lParam-0         }
	HEXM_SETSEL           equ WM_USER+116 ;{wParam-start_offs}	 	{lParam-end_offset}
	HEXM_UNDO             equ WM_USER+117 ;{wParam-0}	        	{lParam-0}
	HEXM_REDO             equ WM_USER+118 ;{wParam-0}	        	{lParam-0}
	HEXM_CANUNDO		  equ WM_USER+119 ;{wParam-0}	        	{lParam-0}
	HEXM_CANREDO          equ WM_USER+120 ;{wParam-0}	        	{lParam-0}
	HEXM_SETREADONLY      equ WM_USER+121 ;{wParam-is_readonly: 1,0}{lParam-0}
.data?
	ALIGN 4
	gdtabs      dd ?
	hFirst      dd ?
	hLast       dd ?
	hMenu       dd ?
	CommandLine dd ?
	libm        dd ?
    dFiles      dd 128*4 dup (?) ; 1-st DD - file_name, 2-nd DD - hWnd, 3-rd DD - file_handle
    filein	    db   512 dup (?)
	file_num    dd ?
	def_sihh    dd ?
.code

start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax
	invoke GetProcessHeap
	mov    glob_heap, eax
	invoke CreateClass
	invoke GetCommandLine
	mov    CommandLine, eax
	invoke LoadLibrary, ADDR sih
	mov    libm, eax
	invoke WinMain, hInstance, 0, CommandLine, SW_SHOWDEFAULT
	invoke FreeLibrary, libm
	invoke ExitProcess, eax

find_themes proc hWin:DWORD
	LOCAL path[512]:BYTE
	LOCAL x_pt[512]:BYTE
	LOCAL ext[4]:BYTE
	LOCAL F_D:WIN32_FIND_DATA
	LOCAL find_h:DWORD
	LOCAL ic_ID:DWORD
	LOCAL lvi:LVITEM
	LOCAL iImage:DWORD
	
	mov    esi, 10010
	invoke GetAppPath, ADDR path
	invoke szCatStr, ADDR path, CADD("Themes\*.ini")
	invoke FindFirstFile, ADDR path, ADDR F_D
	mov    find_h, eax
	cmp    eax, INVALID_HANDLE_VALUE
	jz     exit
@@:	
    invoke AppendMenu, hMenu, MF_STRING, esi, ADDR F_D.cFileName
    inc    esi
    invoke FindNextFile, find_h, ADDR F_D
    or     eax, eax
    jnz    @B 
	invoke FindClose, find_h
exit: 
	xor    eax,eax    
	ret

find_themes endp

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
	LOCAL wc  :WNDCLASSEX
	LOCAL msg :MSG
	LOCAL hwnd:HWND
	
	mov    wc.cbSize, SIZEOF WNDCLASSEX
	mov    wc.style,  0
	mov    wc.lpfnWndProc, OFFSET WndProc
	mov    wc.cbClsExtra, 0
	mov    wc.cbWndExtra, 0
	push   hInstance
	pop    wc.hInstance
	mov    wc.hbrBackground, 0
	mov    wc.lpszMenuName,  10000
	mov    wc.lpszClassName, OFFSET sih
	
	invoke LoadIcon, hInstance, 13333
	mov    wc.hIcon,   eax
	mov    wc.hIconSm, eax
	
	invoke LoadCursor, 0, IDC_ARROW
	mov    wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx, WS_EX_ACCEPTFILES, ADDR sih, ADDR sih,\
           WS_CAPTION+WS_MAXIMIZEBOX+WS_MINIMIZEBOX+WS_SIZEBOX+WS_SYSMENU, 100, 100, 400, 416, 0, 0, hInst, 0
	mov    hwnd, eax
	
	invoke ShowWindow,   hwnd, SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage,  ADDR msg
	.ENDW
	
	mov     eax, msg.wParam
	ret
WinMain endp

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL mii:MENUITEMINFO
	LOCAL attr_cfm:DWORD
	LOCAL attr_mvf:DWORD
	LOCAL file_mem:DWORD
	LOCAL tem1:DWORD
	LOCAL tem2:DWORD
	LOCAL tem3:DWORD
	LOCAL tem4:DWORD
	LOCAL buf[16]:BYTE
	LOCAL caption[512]:BYTE

	
	mov    eax, uMsg
	.if eax==WM_CREATE
		xor    eax,      eax
		mov    file_num, eax
			
		invoke CreateWindowEx, 0, ADDR classname, 0, WS_CHILD+WS_VISIBLE, 0,  0, 420, 31, hWin, 0, hInstance, 0
		mov    gdtabs, eax
		invoke CreateWindowEx, 0, ADDR sihc, 0, WS_CHILD+WS_VISIBLE+WS_VSCROLL, 0, 31, 200, 300, hWin, 0, hInstance, 0
		mov    sihh, eax
		mov    def_sihh, eax
		invoke SendMessage, sihh, HEXM_SETREADONLY, 1, 0
			
		invoke GetMenu, hWin
		mov    hMenu, eax
		invoke GetSubMenu, hMenu, 1
		mov    hMenu, eax
		invoke GetSubMenu, hMenu, 1
		mov    hMenu, eax
		invoke find_themes, hWin
			
		invoke GetMenuItemCount, hMenu
		add    eax, 10007
		mov    hLast, eax
		mov    eax, 10007
		mov    hFirst, eax
		
		mov    wParam, 10007
	@open_profile:
		invoke CheckMenuRadioItem, hMenu, hFirst, hLast, wParam, MF_BYCOMMAND
		invoke DoOpenProfile
		invoke SendMessage, sihh, HEXM_SETFONT, font_num, 0
		invoke SendMessage, sihh, HEXM_SETOFFSETGRADCOL, DWORD PTR [colors+ 0], DWORD PTR [colors+ 4]
		invoke SendMessage, sihh, HEXM_SETHEADERGRADCOL, DWORD PTR [colors+ 8], DWORD PTR [colors+12]
		invoke SendMessage, sihh, HEXM_SETVIEW1TEXTCOL,  DWORD PTR [colors+16], DWORD PTR [colors+20]
		invoke SendMessage, sihh, HEXM_SETHEADERTEXTCOL, DWORD PTR [colors+24], DWORD PTR [colors+28]
		invoke SendMessage, sihh, HEXM_SETVIEW2COL,      DWORD PTR [colors+32], DWORD PTR [colors+36]
		invoke SendMessage, sihh, HEXM_SETVIEW3COL,      DWORD PTR [colors+40], DWORD PTR [colors+44]
		invoke SendMessage, sihh, HEXM_SETVIEW2SELCOL,   DWORD PTR [colors+48], DWORD PTR [colors+52]
		invoke SendMessage, sihh, HEXM_SETVIEW3SELCOL,   DWORD PTR [colors+56], DWORD PTR [colors+60]
		invoke SendMessage, sihh, HEXM_SETACTIVECHARCOL, DWORD PTR [colors+64], DWORD PTR [colors+68]
		invoke SendMessage, sihh, HEXM_SETMODBYTES1COL,  DWORD PTR [colors+72], DWORD PTR [colors+76]
		invoke SendMessage, sihh, HEXM_SETMODBYTES2COL,  DWORD PTR [colors+80], DWORD PTR [colors+84]
		invoke SendMessage, sihh, HEXM_SETMODBYTES3COL,  DWORD PTR [colors+88], DWORD PTR [colors+92]
		invoke SendMessage, sihh, HEXM_SETOFFSET, hex_offset, 0
			
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax==10002
			invoke OpenFileDlg, hWin, hInstance, CADD("Choose file"), CTXT("All files",0,"*.*",0)
			@@OpenFile:
			
			cmp    BYTE PTR [eax], 0
			jz     @cancel
			mov    tem1, eax
			mov    tem2, eax
				
			invoke ShowWindow, sihh, SW_HIDE
				
			xor    esi, esi
				
			invoke szLen, tem2
			add    eax, 1
			mov    ecx, tem2
			add    ecx, eax
			cmp    BYTE PTR [ecx], 0
			jnz    @F
			mov    esi, 1
			jmp    @skip_check
			@@:
			;--------------------------------->>>
			@@:
			invoke szLen, tem2
			add    eax, 1
			add    tem2, eax
			
			mov    eax, tem2
			cmp    BYTE PTR [eax], 0
			jz     @enum_files_done
			
			@skip_check:
				
			cmp    file_num, 128
			jz     @enum_files_done
			add    file_num, 1
			invoke HeapAlloc, glob_heap, 0, 512
			mov    ecx, file_num
			dec    ecx
			shl    ecx, 4
			mov    file_mem, ecx
			mov    DWORD PTR [dFiles+ecx], eax
			mov    fname, eax
			
			invoke szCopy, tem1,  fname
			.if esi==0
				invoke szMultiCat, 2, fname, CADD("\"), tem2
			.endif
				
			mov    eax, sihh
			mov    tem3, eax
			invoke CreateWindowEx, 0, offset sihc, 0, WS_CHILD+WS_VSCROLL, 0, tab_cy, sih_rc_cx, sih_rc_cy, hWin, 0, hInstance, 0
			mov    ecx, file_mem
			mov    DWORD PTR [dFiles+ecx+4], eax ; save handle in array
			mov    sihh, eax
				
			mov    attr_mvf, FILE_MAP_READ
			mov    file, fopenW(fname)
			.if eax == INVALID_HANDLE_VALUE
				mov    file, fopen(fname)
				.if eax == INVALID_HANDLE_VALUE
				@error0:
					invoke DestroyWindow, sihh
					invoke HeapFree, glob_heap, 0, fname
					sub    file_num, 1
					mov    eax, OFFSET sihe
					mov    fname, eax
					mov    eax, tem3
					mov    sihh, eax
					jmp    @directory
				.endif
				mov    attr_cfm, PAGE_READONLY
				invoke SendMessage, sihh, HEXM_SETREADONLY, 1, 0
			.else
				mov    attr_cfm, PAGE_READWRITE
				or     attr_mvf, FILE_MAP_WRITE
			.endif
			
			mov    eax, file
			mov    ecx, file_mem
			mov    DWORD PTR [dFiles+ecx+8], eax ; save handle in array
			
			invoke GetFileSize, file, 0
			mov    fsize, eax
			invoke CreateFileMapping, file, 0, attr_cfm, 0, 0, 0
			
			.if eax!=0
				mov    hmap, eax
				invoke MapViewOfFile, hmap, attr_mvf, 0, 0, 0
				.if eax!=0
					mov    pointer, eax
					mov    ecx, file_mem
					mov    DWORD PTR [dFiles+ecx+12], eax ; save handle in array
					invoke SendMessage, sihh, HEXM_SETPOINTER, pointer, fsize
					invoke GetFileName, fname
					invoke SendMessage, gdtabs, GDTM_ADD, 0, eax
					
					invoke SendMessage, sihh, HEXM_SETFONT, font_num, 0
					invoke SendMessage, sihh, HEXM_SETOFFSETGRADCOL, DWORD PTR [colors+ 0], DWORD PTR [colors+ 4]
					invoke SendMessage, sihh, HEXM_SETHEADERGRADCOL, DWORD PTR [colors+ 8], DWORD PTR [colors+12]
					invoke SendMessage, sihh, HEXM_SETVIEW1TEXTCOL,  DWORD PTR [colors+16], DWORD PTR [colors+20]
					invoke SendMessage, sihh, HEXM_SETHEADERTEXTCOL, DWORD PTR [colors+24], DWORD PTR [colors+28]
					invoke SendMessage, sihh, HEXM_SETVIEW2COL,      DWORD PTR [colors+32], DWORD PTR [colors+36]
					invoke SendMessage, sihh, HEXM_SETVIEW3COL,      DWORD PTR [colors+40], DWORD PTR [colors+44]
					invoke SendMessage, sihh, HEXM_SETVIEW2SELCOL,   DWORD PTR [colors+48], DWORD PTR [colors+52]
					invoke SendMessage, sihh, HEXM_SETVIEW3SELCOL,   DWORD PTR [colors+56], DWORD PTR [colors+60]
					invoke SendMessage, sihh, HEXM_SETACTIVECHARCOL, DWORD PTR [colors+64], DWORD PTR [colors+68]
					invoke SendMessage, sihh, HEXM_SETMODBYTES1COL,  DWORD PTR [colors+72], DWORD PTR [colors+76]
					invoke SendMessage, sihh, HEXM_SETMODBYTES2COL,  DWORD PTR [colors+80], DWORD PTR [colors+84]
					invoke SendMessage, sihh, HEXM_SETMODBYTES3COL,  DWORD PTR [colors+88], DWORD PTR [colors+92]
					invoke SendMessage, sihh, HEXM_SETOFFSET, hex_offset, 0
					
				.else
					jmp    @error0
				.endif
			.else
				jmp    @error0
			.endif
			;|---------------------------------------------
			test   esi, esi
			jz     @B
			@enum_files_done:
			
			invoke ShowWindow, sihh, SW_SHOW
			invoke szCopy, CADD("ShineInHex.dll - "), ADDR caption
			invoke szCatStr, ADDR caption, fname
			invoke SetWindowText, hWin, ADDR caption
			
			@cancel:
			
		.elseif eax==10003
			jmp    @destroy
		.elseif eax==10005
			invoke DialogBoxParam, hInstance, 2000, hWin, ADDR ChooseProc, 0
		.elseif eax==10007
			invoke szCopy, ADDR sih_ini, ADDR ini_file
			jmp    @open_profile
		.elseif eax > 10009
			mov    mii.cbSize, sizeof mii
			mov    mii.fMask,  MIIM_STRING
			lea    ecx, caption
			mov    mii.dwTypeData, ecx
			mov    mii.cch, 64
			invoke GetMenuItemInfo, hMenu, wParam, FALSE, ADDR mii
			invoke szCopy, CADD("Themes\"), ADDR ini_file
			invoke szCatStr, ADDR ini_file, ADDR caption
			jmp    @open_profile
		.endif
		
	.elseif eax==WM_ACTIVATE
		invoke SendMessage, sihh, WM_SETFOCUS, 0, 0
		
	.elseif eax==WM_SIZE
		mov    ecx, lParam
		mov    edx, ecx
		shr    ecx, 16
		sub    ecx, tab_cy
		and    edx, 0ffffh
			
		mov    sih_rc_cx,  edx
		mov    sih_rc_cy,  ecx
			
		invoke MoveWindow, gdtabs, 0, 0, sih_rc_cx, 31, 1
		@resize:
		invoke MoveWindow, sihh, 0, tab_cy, sih_rc_cx, sih_rc_cy, 1
			
	.elseif eax==WM_ERASEBKGND
		mov    eax, 1
		ret	
		
	.elseif eax == WM_DROPFILES
		invoke ShowWindow, sihh, SW_HIDE
		
		invoke DragQueryFile, wParam, -1, 0, 0
		mov    esi, eax
		
		xor    edi, edi
		@@:
		cmp    file_num, 128
		jz     @drag_finish
		add    file_num, 1
		invoke HeapAlloc, glob_heap, 0, 512
		mov    ecx, file_num
		dec    ecx
		shl    ecx, 4
		mov    file_mem, ecx
		mov    DWORD PTR [dFiles+ecx], eax
		mov    fname, eax
		invoke DragQueryFile, wParam, edi, eax, 512
		invoke GetFileAttributes, fname
		and    eax, 10h
		cmp    eax, FILE_ATTRIBUTE_DIRECTORY
		jz     @dir
			
		mov    eax, sihh
		mov    tem1, eax
		invoke CreateWindowEx, 0, offset sihc, 0, WS_CHILD+WS_VSCROLL, 0, tab_cy, sih_rc_cx, sih_rc_cy, hWin, 0, hInstance, 0
		mov    ecx, file_mem
		mov    DWORD PTR [dFiles+ecx+4], eax ; save handle in array
		mov    sihh, eax
			
		mov    attr_mvf, FILE_MAP_READ
		mov    file, fopenW(fname)
		.if eax == INVALID_HANDLE_VALUE
			mov    file, fopen(fname)
			.if eax == INVALID_HANDLE_VALUE
			@error1:
				invoke DestroyWindow, sihh
				@dir:
				invoke HeapFree, glob_heap, 0, fname
				sub    file_num, 1
				mov    eax, OFFSET sihe
				mov    fname, eax
				mov    eax, tem1
				mov    sihh, eax
				jmp    @directory
			.endif
			mov    attr_cfm, PAGE_READONLY
			invoke SendMessage, sihh, HEXM_SETREADONLY, 1, 0
		.else
			mov    attr_cfm, PAGE_READWRITE
			or     attr_mvf, FILE_MAP_WRITE
		.endif
		
		mov    eax, file
		mov    ecx, file_mem
		mov    DWORD PTR [dFiles+ecx+8], eax ; save handle in array
		
		invoke GetFileSize, file, 0
		mov    fsize, eax
		invoke CreateFileMapping, file, 0, attr_cfm, 0, 0, 0
		
		.if eax!=0
			mov    hmap, eax
			invoke MapViewOfFile, hmap, attr_mvf, 0, 0, 0
			.if eax!=0
				mov    pointer, eax
				mov    ecx, file_mem
				mov    DWORD PTR [dFiles+ecx+12], eax ; save handle in array
				invoke SendMessage, sihh, HEXM_SETPOINTER, pointer, fsize
				invoke GetFileName, fname
				invoke SendMessage, gdtabs, GDTM_ADD, 0, eax
				
				invoke SendMessage, sihh, HEXM_SETFONT, font_num, 0
				invoke SendMessage, sihh, HEXM_SETOFFSETGRADCOL, DWORD PTR [colors+ 0], DWORD PTR [colors+ 4]
				invoke SendMessage, sihh, HEXM_SETHEADERGRADCOL, DWORD PTR [colors+ 8], DWORD PTR [colors+12]
				invoke SendMessage, sihh, HEXM_SETVIEW1TEXTCOL,  DWORD PTR [colors+16], DWORD PTR [colors+20]
				invoke SendMessage, sihh, HEXM_SETHEADERTEXTCOL, DWORD PTR [colors+24], DWORD PTR [colors+28]
				invoke SendMessage, sihh, HEXM_SETVIEW2COL,      DWORD PTR [colors+32], DWORD PTR [colors+36]
				invoke SendMessage, sihh, HEXM_SETVIEW3COL,      DWORD PTR [colors+40], DWORD PTR [colors+44]
				invoke SendMessage, sihh, HEXM_SETVIEW2SELCOL,   DWORD PTR [colors+48], DWORD PTR [colors+52]
				invoke SendMessage, sihh, HEXM_SETVIEW3SELCOL,   DWORD PTR [colors+56], DWORD PTR [colors+60]
				invoke SendMessage, sihh, HEXM_SETACTIVECHARCOL, DWORD PTR [colors+64], DWORD PTR [colors+68]
				invoke SendMessage, sihh, HEXM_SETMODBYTES1COL,  DWORD PTR [colors+72], DWORD PTR [colors+76]
				invoke SendMessage, sihh, HEXM_SETMODBYTES2COL,  DWORD PTR [colors+80], DWORD PTR [colors+84]
				invoke SendMessage, sihh, HEXM_SETMODBYTES3COL,  DWORD PTR [colors+88], DWORD PTR [colors+92]
				invoke SendMessage, sihh, HEXM_SETOFFSET, hex_offset, 0
				
			.else
				jmp    @error1
			.endif
		.else
			jmp    @error1
		.endif
		;|---------------------------------------------
		@directory:
		inc    edi
		cmp    esi, edi
		jnz    @B
		@drag_finish:
		
		invoke DragFinish, wParam
		invoke ShowWindow, sihh, SW_SHOW
		invoke szCopy, CADD("ShineInHex.dll - "), ADDR caption
		invoke szCatStr, ADDR caption, fname
		invoke SetWindowText, hWin, ADDR caption
			
	.elseif eax==GDTM_CLOSED
		mov    ecx, wParam
		dec    ecx
		shl    ecx, 4
		
		mov    eax, [dFiles+ecx+0]
		mov    tem1, eax
		mov    eax, [dFiles+ecx+4]
		mov    tem2, eax
		mov    eax, [dFiles+ecx+8]
		mov    tem3, eax
		mov    eax, [dFiles+ecx+12]
		mov    tem4, eax
		
		invoke HeapFree, glob_heap, 0, tem1
		invoke DestroyWindow, tem2
		invoke UnmapViewOfFile, tem4
		fclose(tem3)
			
		mov    ecx, file_num
		sub    ecx, wParam
		shl    ecx, 4
		mov    eax, wParam
		shl    eax, 4
		add    eax, OFFSET dFiles
		mov    edx, eax
		sub    edx, 16
		invoke RtlMoveMemory, edx, eax, ecx
		sub    file_num, 1
		
		mov    ecx, file_num
		.if ecx == 0
			invoke ShowWindow, def_sihh, SW_SHOW
			invoke SetWindowText, hWin, ADDR sih
			mov    eax, def_sihh
			mov    sihh, eax
			jmp    @resize
		.else
			shl    ecx, 4
			mov    [dFiles+ecx+4], 0
			invoke SendMessage, gdtabs, GDTM_GETACTIVE, 0, 0
			mov    ecx, eax
			jmp    @show
		.endif
		
	.elseif eax==GDTM_ACTIVATED
		mov    ecx, wParam ; previous active tab
		dec    ecx
		shl    ecx, 4
		invoke ShowWindow, [dFiles+ecx+4], SW_HIDE
		mov    ecx, lParam ; current  active tab
		@show:
		dec    ecx
		shl    ecx, 4
		mov    eax, [dFiles+ecx+0]
		mov    fname, eax
		mov    eax, [dFiles+ecx+4]
		mov    sihh, eax
		invoke szCopy, CADD("ShineInHex.dll - "), ADDR caption
		invoke szCatStr, ADDR caption, fname
		invoke SetWindowText, hWin, ADDR caption
		invoke SetFocus, sihh
		invoke ShowWindow, sihh, SW_SHOW
		jmp    @resize
		
	.elseif eax==WM_DESTROY
		@destroy:
		.if file_num != 0
			sub    file_num, 1
			mov    ecx, file_num
			shl    ecx, 4
			mov    eax, [dFiles+ecx+0]
			mov    fname, eax
			mov    eax, [dFiles+ecx+4]
			mov    sihh, eax
			mov    eax, [dFiles+ecx+8]
			mov    file, eax
			mov    eax, [dFiles+ecx+12]
			mov    pointer, eax
			
			invoke HeapFree, glob_heap, 0, fname
			invoke DestroyWindow, sihh
			;invoke SendMessage, sihh, HEXM_UNSETPOINTER, 0, 0
			invoke UnmapViewOfFile, pointer
			fclose(file)
			jmp    @destroy
		.endif
		invoke PostQuitMessage, 0
	.else
		invoke DefWindowProc, hWin, uMsg, wParam, lParam		
		ret
	.endif
	
	xor eax,eax
	@done:
	ret
WndProc endp

DoOpenProfile PROC
	LOCAL path[512]:BYTE
	
	invoke GetAppPath, ADDR path
	invoke szCatStr,   ADDR path, ADDR ini_file
	
	mov    font_num,  FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("font_number"),    00000000h, ADDR path)

	mov    DWORD PTR [colors+  0], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("offset_grad_start_color"), 	0FF8080h, ADDR path)
	mov    DWORD PTR [colors+  4], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("offset_grad_end_color"), 	0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+  8], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("header_grad_start_color"),	0808080h, ADDR path)
	mov    DWORD PTR [colors+ 12], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("header_grad_end_color"),   	0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 16], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("header_info_text_color"),   0000000h, ADDR path)
	mov    DWORD PTR [colors+ 20], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("view1_text_color"),   		0FF8080h, ADDR path)
	mov    DWORD PTR [colors+ 24], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("header_addr_text_color"),   0000000h, ADDR path)
	mov    DWORD PTR [colors+ 28], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("header_input_mode_text_color"), 0000000h, ADDR path)
	mov    DWORD PTR [colors+ 32], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("view2_bk_color"),   		0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 36], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("view2_text_color"),   		0800000h, ADDR path)
	mov    DWORD PTR [colors+ 40], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("view3_bk_color"),   		0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 44], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("view3_text_color"),   		0008000h, ADDR path)
	mov    DWORD PTR [colors+ 48], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("sel2_bk_color"),   			0FF8080h, ADDR path)
	mov    DWORD PTR [colors+ 52], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("sel2_text_color"),   		0C0FFC0h, ADDR path)
	mov    DWORD PTR [colors+ 56], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("sel3_bk_color"),   			0808000h, ADDR path)
	mov    DWORD PTR [colors+ 60], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("sel3_text_color"),   		0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 64], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("char_bk_color"),   			00000FFh, ADDR path)
	mov    DWORD PTR [colors+ 68], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("char_text_color"),   		0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 72], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified1_bytes_bk_color"), 0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 76], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified1_bytes_text_color"), 00000F0h, ADDR path)
	mov    DWORD PTR [colors+ 80], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified2_bytes_bk_color"),   0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 84], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified2_bytes_text_color"), 00000B0h, ADDR path)
	mov    DWORD PTR [colors+ 88], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified1_bytes_bk_color"),   0FFFFFFh, ADDR path)
	mov    DWORD PTR [colors+ 92], FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("modified3_bytes_text_color"), 0000070h, ADDR path)
	mov    hex_offset, FUNC(GetPrivateProfileInt, ADDR ini_sec1,  CADD("offset"),  0, ADDR path)
	
	xor    eax, eax
	ret
	
DoOpenProfile ENDP	
	
DoSaveProfile PROC
	LOCAL buf [32] :BYTE
	LOCAL path[512]:BYTE
	
	invoke GetAppPath, ADDR path
	invoke szCatStr,   ADDR path, ADDR ini_file

	invoke wsprintf, ADDR buf, ADDR ini_hex, font_num
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("font_number"),    ADDR buf, ADDR path
	
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+  0]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("offset_grad_start_color"), ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+  4]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("offset_grad_end_color"),   ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+  8]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("header_grad_start_color"), ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 12]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("header_grad_end_color"),   ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 16]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("header_info_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 20]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("view1_text_color"),        ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 24]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("header_addr_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 28]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("header_input_mode_text_color"), ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 32]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("view2_bk_color"),   ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 36]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("view2_text_color"), ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 40]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("view3_bk_color"),   ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 44]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("view3_text_color"), ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 48]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("sel2_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 52]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("sel2_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 56]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("sel3_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 60]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("sel3_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 64]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("char_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 68]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("char_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 72]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified1_bytes_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 76]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified1_bytes_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 80]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified2_bytes_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 84]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified2_bytes_text_color"),  ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 88]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified3_bytes_bk_color"),    ADDR buf, ADDR path
	invoke wsprintf, ADDR buf, ADDR ini_hex, DWORD PTR [colors+ 92]
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("modified3_bytes_text_color"),  ADDR buf, ADDR path
	
	invoke wsprintf, ADDR buf, ADDR ini_hex, hex_offset
	invoke WritePrivateProfileString, ADDR ini_sec1,  CADD("offset"),  ADDR buf, ADDR path
	
	xor    eax, eax
	ret
	
DoSaveProfile ENDP

ChooseProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL hex_offs[16]:BYTE
	LOCAL buf[32]:BYTE
	
	mov    eax, uMsg
	.if eax==WM_INITDIALOG
			
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("0 - Fixedsys")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("1 - Courier")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("2 - Terminal")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("3 - Courier New")
		invoke SendDlgItemMessage, hWin, 2002, CB_ADDSTRING, 0, CADD("4 - Lucida Console")
		
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Offset grad start color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Header grad start color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Header info text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Header addr text color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View2 selection bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("View3 selection bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Active char bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Modified1 bytes bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Modified2 bytes bk color")
		invoke SendDlgItemMessage, hWin, 2008, CB_ADDSTRING, 0, CADD("Modified3 bytes bk color")
		
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Offset grad end color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Header grad end color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("View1 text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Header input mode text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("View2 text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("View3 text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("View2 selection text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("View3 selection text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Active char text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Modified1 bytes text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Modified2 bytes text color")
		invoke SendDlgItemMessage, hWin, 2009, CB_ADDSTRING, 0, CADD("Modified3 bytes text color")
		
		invoke SendDlgItemMessage, hWin, 2002, CB_SETCURSEL, font_num, 0
		invoke SendDlgItemMessage, hWin, 2008, CB_SETCURSEL, 0, 0
		invoke SendDlgItemMessage, hWin, 2009, CB_SETCURSEL, 0, 0
		
		mov    DWORD PTR [col_br+0], FUNC(CreateSolidBrush, DWORD PTR [colors+0])
		mov    DWORD PTR [col_br+4], FUNC(CreateSolidBrush, DWORD PTR [colors+4])
		mov    DWORD PTR [col_st+0], FUNC(GetDlgItem, hWin, 2004)
		mov    DWORD PTR [col_st+4], FUNC(GetDlgItem, hWin, 2005)
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		mov    ecx, eax
		shr    eax, 16
		.if eax==CBN_SELCHANGE
			and    ecx, 0ffffh
			.if ecx==2002
				mov    font_num, FUNC(SendDlgItemMessage, hWin, ecx, CB_GETCURSEL, 0, 0) 
			.elseif ecx==2008 || ecx==2009
				mov    esi, ecx
				sub    esi, 2008
				shl    esi, 2
				mov    edi, ecx
				invoke DeleteObject, DWORD PTR [col_br+0]
				invoke DeleteObject, DWORD PTR [col_br+4]
				invoke SendDlgItemMessage, hWin, edi, CB_GETCURSEL, 0, 0
				mov    edi, eax
				mov    DWORD PTR [col_br+esi], FUNC(CreateSolidBrush, DWORD PTR [colors+edi*8+esi])
				xor    esi, 4
				mov    DWORD PTR [col_br+esi], FUNC(CreateSolidBrush, DWORD PTR [colors+edi*8+esi])
				shr    esi, 2
				mov    ecx, 2008
				add    ecx, esi
				invoke SendDlgItemMessage, hWin, ecx, CB_SETCURSEL, edi, 0
				invoke InvalidateRect, DWORD PTR [col_st+0], 0, 0
				invoke InvalidateRect, DWORD PTR [col_st+4], 0, 0
			.endif
		.endif
		.if wParam==2004 || wParam==2005
			mov    esi, wParam
			sub    esi, 2004
			invoke ColorDialog, hWin, hInstance, 0
			.if eax!=0
				mov    edi, eax
				invoke DeleteObject, DWORD PTR [col_br+esi*4]
				mov    ecx, 2008
				add    ecx, esi
				invoke SendDlgItemMessage, hWin, ecx, CB_GETCURSEL, 0, 0
				;4
				shl    esi, 2
				mov    DWORD PTR [colors+eax*8+esi], edi
				mov    DWORD PTR [col_br+esi], FUNC(CreateSolidBrush, edi)
				invoke InvalidateRect, DWORD PTR [col_st+esi], 0, 0
			.endif
		.elseif wParam==2006 || wParam==2007
			invoke SendMessage, sihh, HEXM_SETFONT, font_num, 0
			invoke SendMessage, sihh, HEXM_SETOFFSETGRADCOL, DWORD PTR [colors+ 0], DWORD PTR [colors+ 4]
			invoke SendMessage, sihh, HEXM_SETHEADERGRADCOL, DWORD PTR [colors+ 8], DWORD PTR [colors+12]
			invoke SendMessage, sihh, HEXM_SETVIEW1TEXTCOL,  DWORD PTR [colors+16], DWORD PTR [colors+20]
			invoke SendMessage, sihh, HEXM_SETHEADERTEXTCOL, DWORD PTR [colors+24], DWORD PTR [colors+28]
			invoke SendMessage, sihh, HEXM_SETVIEW2COL,      DWORD PTR [colors+32], DWORD PTR [colors+36]
			invoke SendMessage, sihh, HEXM_SETVIEW3COL,      DWORD PTR [colors+40], DWORD PTR [colors+44]
			invoke SendMessage, sihh, HEXM_SETVIEW2SELCOL,   DWORD PTR [colors+48], DWORD PTR [colors+52]
			invoke SendMessage, sihh, HEXM_SETVIEW3SELCOL,   DWORD PTR [colors+56], DWORD PTR [colors+60]
			invoke SendMessage, sihh, HEXM_SETACTIVECHARCOL, DWORD PTR [colors+64], DWORD PTR [colors+68]
			invoke SendMessage, sihh, HEXM_SETMODBYTES1COL,  DWORD PTR [colors+72], DWORD PTR [colors+76]
			invoke SendMessage, sihh, HEXM_SETMODBYTES2COL,  DWORD PTR [colors+80], DWORD PTR [colors+84]
			invoke SendMessage, sihh, HEXM_SETMODBYTES3COL,  DWORD PTR [colors+88], DWORD PTR [colors+92]
			invoke SendDlgItemMessage, hWin, 2010, WM_GETTEXT, 9, ADDR hex_offs
			invoke htodw, ADDR hex_offs
			mov    hex_offset, eax
			invoke SendMessage, sihh, HEXM_SETOFFSET, hex_offset, 0
			invoke DoSaveProfile
			.if wParam==2006
				invoke EndDialog, hWin, 1
			.endif
		.elseif wParam==2020
			invoke EndDialog, hWin, 2
		.endif
		
	.elseif eax==WM_CTLCOLORSTATIC
		mov    eax, DWORD PTR [col_st+0]
		mov    ecx, DWORD PTR [col_st+4]
		.if lParam==eax
			mov eax, DWORD PTR [col_br+0]
		.elseif lParam==ecx
			mov eax, DWORD PTR [col_br+4]
		.else
			xor eax, eax
		.endif
		ret
		
	.elseif eax==WM_CLOSE
		invoke DeleteObject, DWORD PTR [col_br+0]
		invoke DeleteObject, DWORD PTR [col_br+4]
		invoke EndDialog, hWin, 0
		
	.else
		mov    eax,FALSE
		ret
	.endif
	mov    eax,TRUE
	ret
ChooseProc endp

GetFileName proc uses edi lpszFilename:dword
;---------------------------------------
    mov     eax, lpszFilename
    mov     edi, eax
    test    eax, eax
    jz      done
    invoke  lstrlen, eax
    test    eax, eax
    jz      done
    lea     ecx, [eax+edi]
next:
    cmp     ecx, edi
    jb      son
    mov     al, [ecx]
    cmp     al, '\'
    jz      son
    cmp     al, ':'
    jz      son
    sub     ecx, 1
    jmp     next
son:
    lea     eax, [ecx+1]
done:
    ret
;---------------------------------------
GetFileName endp

align 4

OpenFileDlg proc hParent:DWORD,Instance:DWORD,lpTitle:DWORD,lpFilter:DWORD

    LOCAL ofn:OPENFILENAME

    .data?
      openfilebuffer db 1024 dup (?)
    .code

    mov eax, OFFSET openfilebuffer
    mov BYTE PTR [eax], 0

  ; --------------------
  ; zero fill structure
  ; --------------------
    push edi
    mov ecx, sizeof OPENFILENAME
    mov al, 0
    lea edi, ofn
    rep stosb
    pop edi

    mov ofn.lStructSize,    sizeof OPENFILENAME
    m2m ofn.hWndOwner,      hParent
    m2m ofn.hInstance,      Instance
    m2m ofn.lpstrFilter,    lpFilter
    m2m ofn.lpstrFile,      offset openfilebuffer
    mov ofn.nMaxFile,       sizeof openfilebuffer
    m2m ofn.lpstrTitle,     lpTitle
    mov ofn.Flags,          OFN_EXPLORER +OFN_FILEMUSTEXIST+OFN_HIDEREADONLY+\
                            OFN_LONGNAMES+OFN_ALLOWMULTISELECT

    invoke GetOpenFileName, ADDR ofn
    mov    eax, OFFSET openfilebuffer
    ret

OpenFileDlg endp

end start
